#!/usr/bin/env bash

readonly LOG_DIR="support_file"

function create_support_file_dir {
  local LOG_DIR_ABSOLUTE="/programs/${LOG_DIR}"
  if file_exists ${LOG_DIR_ABSOLUTE} ; then
    rm -r "${LOG_DIR_ABSOLUTE}"
  fi
   mkdir "${LOG_DIR_ABSOLUTE}"
}

# Send command to Dashboard Server
function dashboard_command {
    # send dashboard command to the server and "quit" to return, then cut away the first and last line and preserve only
    # output related to the command.
    (
        echo "$1"
        echo "quit"
    ) | nc 127.0.0.1 29999 | tail -n +2 | head -1
}

function extract_support_file {
    local support_file_extraction_result=$(dashboard_command "generate support file ${LOG_DIR}")
    echo "${support_file_extraction_result}"
}

function file_exists() { [[ -e $1 ]]; }


function main {
    create_support_file_dir
    extract_support_file

}

main
exit 0